/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:preserve.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include "ed.h"

extern char *ReadWildCard();

int
preserve()
{
	int i;
	char savedir[MAXPATHLEN+1];
	char rmdirs[MAXPATHLEN+1];
	char tmppath[MAXPATHLEN+1];
	EditLine *ed;

	getcwd(tmppath, MAXPATHLEN);
	sprintf(savedir, "%s/neTmp", NxDEFPath);
	strcpy(rmdirs, savedir);
	if (chdir(savedir) != 0) {
		chdir(tmppath);
		return FALSE;
	}
	strcat(savedir, "/Nx*");
	if (FileOpenOp(savedir, 1) == FALSE) {
		chdir(tmppath);
		return FALSE;
	}
	for (i = FILE_START; i < MAXEDIT; i++) {
		if (EditPathName[i][0] != '\0') {
			CurrentFileNo = i;
			ed = (EditLine *)GetTop();
			strcpy(EditPathName[CurrentFileNo], ed->buffer);
			strcat(EditFileName[CurrentFileNo], ed->buffer);
			DeleteList(ed);
			SetFileChangeFlag();
		}
	}
	chdir(tmppath);

	while (ReadWildCard(tmppath, savedir) != NULL) {
		unlink(tmppath);
	}
	rmdir(rmdirs);

	return TRUE;
}
