/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:scanfs.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include	<ctype.h>
#include	"ed.h"

extern char *edlin();
static int curPos;
static int Scroll;

VOID
PrintScanf(buffer, crt_width)
char *buffer;
register int crt_width;
{
	char *buff;
	char d_buffer[MAXEDITLINE+1];

	Tab_Space(buffer, d_buffer);
	buff = d_buffer;
	buff += Scroll;
	printw("%-.*s<", crt_width-2, buff);
}

/*-------------------------------------------------------------------

-------------------------------------------------------------------*/
int
scanfs(row, col, buffer, crt_width , max_input)
register int row;
register int col;
char *buffer;
register int crt_width;
register int max_input;
{
	int input_len;
	register int ch;
	register int in_flag;
	char inputbuff[MAXEDITLINE+1];

	strcpy(inputbuff, buffer);
	input_len = strlen(inputbuff)+1;
	if (crt_width -2 < input_len-1) {
		curPos = crt_width-2;
		Scroll = input_len - crt_width + 1;
	} else {
		curPos = input_len-1;
		Scroll = 0;
	}

	move(row, col);
	clrtoeol();
	CrtNormal(stdscr);
	CrtReverse(stdscr);
	PrintScanf(inputbuff, crt_width);

	in_flag = FALSE;
	for (;;) {
		move(row, col+curPos);
		ch = inkey();
		switch(GetSyStemKey(ch)) {
		case KEY_BACKSPACE:
			in_flag = TRUE;
			if (1 < input_len) {
				edlin(ch, inputbuff, sizeof(inputbuff), &input_len, INSERT, STOP, BACKSPACE);
				if (0 < curPos) {
					curPos--;
				} else if (0 == curPos && 0 < Scroll) {
					Scroll--;
				}
			}
			break;
		case KEY_DC:
			in_flag = TRUE;
			edlin(ch, inputbuff, sizeof(inputbuff), &input_len, INSERT, STOP, DELETE);
			break;
		case KEY_LEFT:
			in_flag = TRUE;
			if (1 < input_len) {
				input_len--;
				if (0 < curPos) {
					curPos--;
				} else if (0 == curPos && 0 < Scroll) {
					Scroll--;
				}
			} else {
				flash();
			}
			break;
		case KEY_RIGHT:
			in_flag = TRUE;
			if (input_len+1 < max_input && input_len < strlen(inputbuff)+1) {
				input_len++;
				if (curPos < crt_width-2) {
					curPos++;
				} else if (curPos == crt_width-2) {
					Scroll++;
				}
			} else {
				flash();
			}
			break;
		case KEY_ENTER:
			strcpy(buffer, inputbuff);
			return TRUE;
		case KEY_CANCEL:
			return ESCAPE;
		default:
			if (!iscntrl(ch)) {
				if (in_flag == FALSE) {
					strcpy(inputbuff, "");
					input_len = 1;
					curPos = 0;
					Scroll = 0;
					move(row, col);
					clrtoeol();
					CrtNormal(stdscr);
					PrintScanf(inputbuff, crt_width);
			 		in_flag = TRUE;
				}

				if (input_len+1 < max_input) {
					if (curPos < crt_width-2) {
						curPos++;
					} else if (curPos == crt_width-2) {
						Scroll++;
					}
					edlin(ch, inputbuff, sizeof(inputbuff), &input_len, INSERT, STOP, NONE);
				} else {
					flash();
				}
			}
			break;
		}
		move(row, col);
		clrtoeol();
		CrtNormal(stdscr);
		PrintScanf(inputbuff, crt_width);
	}
}
