/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:shells.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include "ed.h"

static char sys_buffer[MAXEDITLINE+1];

/*-------------------------------------------------------------------
	Set my "Shell"
-------------------------------------------------------------------*/
VOID
SetSHELL()
{
	if ((Shell = getenv("SHELL")) == NULL) {
		Shell = "/bin/sh";
	}
}

/*-------------------------------------------------------------------
	Escape Shell
-------------------------------------------------------------------*/
VOID
CommandCom(sys_buff)
char *sys_buff;
{
	clear();
	refresh();
	ResetTTY();
	endwin();

	if (*sys_buff == '\0') {
		fputs(TYPE_EXIT_MSG, stderr);

		system(Shell);
		SetTTY();
	} else {
		fputs(sys_buff, stderr);
		fputc('\n', stderr);

		system(sys_buff);

		fputs(HIT_ANY_KEY_MSG, stderr);
		SetTTY();
		inkey();
	}
	initterm();
	clear();
	CrtDrawAll();
}

VOID
ShellEscape()
{
	if (HisGets(sys_buffer, GETS_SHELL_MSG, SHELLS_SYSTEM) != NULL) {
		CommandCom(sys_buffer);
	}
	/*BelowLineDraw();*/
}

VOID
ShellEscapeStr(buffer)
char *buffer;
{

	if (*buffer != '\0') {
		strcpy(sys_buffer, buffer);
	}
	CommandCom(buffer);
}

char *
GetShellStr()
{
	return sys_buffer;
}

VOID
SetShellStr(buffer)
char *buffer;
{
	strcpy(sys_buffer, buffer);
}

/*-------------------------------------------------------------------
	System Command
-------------------------------------------------------------------*/
VOID
SystemCommandOp()
{
	if (HisGets(sys_buffer, GETS_SYSTEM_MSG, SYSTEM_SYSTEM) == NULL) {
		refresh();
	} else {
		SystemCommand(sys_buffer);
	}
}
