#define	initscr()	(inittty(0), getterment())
#define	endwin()	(locate(0, n_line-1), endterm())
#define	move(y, x)	locate(x, y)
#define	addch(c)	putch(c)
#define	addstr(s)	cputs(s)
#define	printw		cprintf
#define	mvprintw	locate_cprintf
#define	mvaddch(y, x, c)	(locate(x, y), putch(c))
#define	mvaddstr(y, x, s)	(locate(x, y), cputs(s))
#define	insertln()	putterm(l_insert)
#define	deleteln()	putterm(l_delete)
#define	clear()		putterm(t_clear)
#define	clrtoeol()	putterm(l_clear)
#define	refresh()	tflush()
#define	wrefresh(w)	tflush()
#define	flash()		putterm(t_vbell)
#define	flushinp()	keyflush()
#define	curs_set(i)	putterm((i)?(((i)>1)?t_highcursor:t_normalcursor)\
			:t_nocursor)
#define	garbagedlines(w, b, n)	(locate(0, b))
#define	idlok(w, f)

#ifdef	TRUE
#undef	TRUE
#endif
#ifdef	FALSE
#undef	FALSE
#endif

#define	TRUE	(1)
#define	FALSE	(0)
#define	ERR	(0)
#define	OK	(1)

#define	ACS_BSSB	'+'
#define	ACS_SSBB	'+'
#define	ACS_BBSS	'+'
#define	ACS_SBBS	'+'
#define	ACS_SBSS	'+'
#define	ACS_SSSB	'+'
#define	ACS_SSBS	'+'
#define	ACS_BSSS	'+'
#define	ACS_BSBS	'-'
#define	ACS_SBSB	'|'
#define	ACS_SSSS	'+'

#define	ACS_ULCORNER	ACS_BSSB
#define	ACS_LLCORNER	ACS_SSBB
#define	ACS_URCORNER	ACS_BBSS
#define	ACS_LRCORNER	ACS_SBBS
#define	ACS_RTEE	ACS_SBSS
#define	ACS_LTEE	ACS_SSSB
#define	ACS_BTEE	ACS_SSBS
#define	ACS_TTEE	ACS_BSSS
#define	ACS_HLINE	ACS_BSBS
#define	ACS_VLINE	ACS_SBSB
#define	ACS_PLUS	ACS_SSSS
#define	ACS_S1		'-'
#define	ACS_S9		'_'
#define	ACS_DIAMOND	'+'
#define	ACS_CKBOARD	':'
#define	ACS_DEGREE	'\''
#define	ACS_PLMINUS	'#'
#define	ACS_BULLET	'o'
#define	ACS_LARROW	'>'
#define	ACS_RARROW	'<'
#define	ACS_DARROW	'v'
#define	ACS_UARROW	'^'
#define	ACS_BOARD	'#'
#define	ACS_LANTERN	'#'
#define	ACS_BLOCK	'#'

#define	KEY_MIN		0401
#define	KEY_BREAK	0401
#define	KEY_DOWN	0402
#define	KEY_UP		0403
#define	KEY_LEFT	0404
#define	KEY_RIGHT	0405
#define	KEY_HOME	0406
#define	KEY_BACKSPACE	0407
#define	KEY_F0		0410
#define	KEY_F(n)	(KEY_F0+(n))
#define	KEY_DL		0510
#define	KEY_IL		0511
#define	KEY_DC		0512
#define	KEY_IC		0513
#define	KEY_EIC		0514
#define	KEY_CLEAR	0515
#define	KEY_EOS		0516
#define	KEY_EOL		0517
#define	KEY_SF		0520
#define	KEY_SR		0521
#define	KEY_NPAGE	0522
#define	KEY_PPAGE	0523
#define	KEY_STAB	0524
#define	KEY_CTAB	0525
#define	KEY_CATAB	0526
#define	KEY_ENTER	0527
#define	KEY_SRESET	0530
#define	KEY_RESET	0531
#define	KEY_PRINT	0532
#define	KEY_LL		0533
#define	KEY_A1		0534
#define	KEY_A3		0535
#define	KEY_B2		0536
#define	KEY_C1		0537
#define	KEY_C3		0540
#define	KEY_BTAB	0541
#define	KEY_BEG		0542
#define	KEY_CANCEL	0543
#define	KEY_CLOSE	0544
#define	KEY_COMMAND	0545
#define	KEY_COPY	0546
#define	KEY_CREATE	0547
#define	KEY_END		0550
#define	KEY_EXIT	0551
#define	KEY_FIND	0552
#define	KEY_HELP	0553
#define	KEY_MARK	0554
#define	KEY_MESSAGE	0555
#define	KEY_MOVE	0556
#define	KEY_NEXT	0557
#define	KEY_OPEN	0560
#define	KEY_OPTIONS	0561
#define	KEY_PREVIOUS	0562
#define	KEY_REDO	0563
#define	KEY_REFERENCE	0564
#define	KEY_REFRESH	0565
#define	KEY_REPLACE	0566
#define	KEY_RESTART	0567
#define	KEY_RESUME	0570
#define	KEY_SAVE	0571
#define	KEY_SBEG	0572
#define	KEY_SCANCEL	0573
#define	KEY_SCOMMAND	0574
#define	KEY_SCOPY	0575
#define	KEY_SCREATE	0576
#define	KEY_SDC		0577
#define	KEY_SDL		0600
#define	KEY_SELECT	0601
#define	KEY_SEND	0602
#define	KEY_SEOL	0603
#define	KEY_SEXIT	0604
#define	KEY_SFIND	0605
#define	KEY_SHELP	0606
#define	KEY_SHOME	0607
#define	KEY_SIC		0610
#define	KEY_SLEFT	0611
#define	KEY_SMESSAGE	0612
#define	KEY_SMOVE	0613
#define	KEY_SNEXT	0614
#define	KEY_SOPTIONS	0615
#define	KEY_SPREVIOUS	0616
#define	KEY_SPRINT	0617
#define	KEY_SREDO	0620
#define	KEY_SREPLACE	0621
#define	KEY_SRIGHT	0622
#define	KEY_SRSUME	0623
#define	KEY_SSAVE	0624
#define	KEY_SSUSPEND	0625
#define	KEY_SUNDO	0626
#define	KEY_SUSPEND	0627
#define	KEY_UNDO	0630
#define	KEY_MAX		0777
