/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:edlin.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include 	"ed.h"

/*-------------------------------------------------------------------

-------------------------------------------------------------------*/
char *
edlin(ich, buffer, max_length, col, input_mode, cursor_mode, contrl_flg)
register int ich;
char *buffer;
register int max_length;
register int *col;
register int input_mode;	/*INSERT / OVERWRITE*/
register int cursor_mode;
register int contrl_flg;
{
	register int i;
	register int input_len;
	register int strlength;
	char tmpbuff[MAXEDITLINE+1];

	strlength = strlen(buffer);
	input_len = *col-1;
	if (cursor_mode == FREE) {
		for (i = strlength; i < input_len; i++) {
			buffer[i] = ' ';
		}
		buffer[i] = '\0';
		strlength = strlen(buffer);
	} else {
		if (strlength < input_len) {
			input_len = strlength;
		}
	}
	/*Back Space*/
	if (contrl_flg == BACKSPACE) {
		if (input_len <= strlength) {
			input_len--;
			for (i = input_len; i < strlength; i++) {
				buffer[i] = buffer[i+1];
			}
		}
	/*Delete Charactor*/
	} else if (contrl_flg == DELETE) {
		if (input_len-1 <= strlength) {
			for (i = input_len; i < strlength; i++) {
				buffer[i] = buffer[i+1];
			}
		}
	/*Input Charactor*/
	} else if (input_len < max_length) {
		strcpy(tmpbuff, buffer);
		buffer[input_len]=(char)ich;
		for (i = input_len; i < strlength; i++) {
			buffer[i+1] = tmpbuff[i];
		}
		buffer[i+1] = '\0';
		input_len++;
	}
	*col = input_len+1;
	return buffer;
}
