/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:kanji.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include "ed.h"

int
IsKanjiPosition()
{
	register int i;
	register int strlength;
	register EditLine *ed;

	ed = (EditLine *)GetList(GetLineOffset());
	strlength = strlen(ed->buffer);
	i = GetBufferOffset()-1;

	if (i < strlength) {
		if (IsKanji(ed->buffer[i]) && IsKanji2(ed->buffer[i+1])) {
			return TRUE;
		}
	}
	return FALSE;
}

int
IsThisKanjiPosition(offset, buffer)
int offset;
char *buffer;
{
	register int i;
	register int Iskanji_flg;

	for (i = 0; i <= offset; i++) {
		if (IsKanji(buffer[i]) && IsKanji2(buffer[i+1])) {
			i++;
			Iskanji_flg = TRUE;
		} else {
			Iskanji_flg = FALSE;
		}
	}
	if (i == offset+1) {
		return FALSE;
	} else {
		return Iskanji_flg;
	}
}

VOID
ResetKanjiPosition()
{
	register int i;
	register int strlength;
	register EditLine *ed;
	register int beforeIskanji_flg;

	OffsetSetByColum(GetLineOffset());

	ed = (EditLine *)GetList(GetLineOffset());
	strlength = strlen(ed->buffer);
	beforeIskanji_flg = FALSE;
	for (i = 0; i < GetBufferOffset() && i <= strlength; i++) {
		if (IsKanji(ed->buffer[i]) && IsKanji2(ed->buffer[i+1])) {
			i++;
			beforeIskanji_flg = TRUE;
		} else {
			beforeIskanji_flg = FALSE;
		}
	}
	if (beforeIskanji_flg == TRUE) {
		SetBufferOffset(i-1);
	}
}
