/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:key.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01
--------------------------------------------------------------------*/
#include "ed.h"

int
keypadFunction(key, flag)
register int key;
register int flag;
{
	switch(key) {
	case KEY_DOWN:
		if (flag == FALSE) {
			(*helpDefBuff[_CURSORDOWN])();
		} else {
			CursorDownOp();
		}
		break;
	case KEY_UP:
		if (flag == FALSE) {
			(*helpDefBuff[_CURSORUP])();
		} else {
			CursorUpOp();
		}
		break;
	case KEY_LEFT:
		if (flag == FALSE) {
			(*helpDefBuff[_CURSORLEFT])();
		} else {
			CursorLeftOp();
		}
		break;
	case KEY_RIGHT:
		if (flag == FALSE) {
			(*helpDefBuff[_CURSORRIGHT])();
		} else {
			CursorRightOp();
		}
		break;
	case KEY_HOME:
		if (flag == FALSE) {
			(*helpDefBuff[_TOGGLEFILE])();
		} else {
			toggleFileOp();
		}
		break;
	case KEY_F(1):
		if (flag == FALSE) {
			(*helpDefBuff[_FILEMENU])();
		} else {
			FileMenu();
		}
		break;
	case KEY_F(2):
		if (flag == FALSE) {
			(*helpDefBuff[_CHANGEFILE])();
		} else {
			ChangeFileOp();
		}
		break;
	case KEY_F(3):
		if (flag == FALSE) {
			(*helpDefBuff[_SEEOPTIONS])();
		} else {
			SeeOptionOp();
		}
		break;
	case KEY_F(4):
		if (flag == FALSE) {
			(*helpDefBuff[_SEARCHFORWARD])();
		} else {
			SearchForwardOp();
		}
		break;
	case KEY_F(5):
		if (flag == FALSE) {
			(*helpDefBuff[_MULTIFILESEARCH])();
		} else {
			MultiFileSearch();
		}
		break;
	case KEY_F(6):
		if (flag == FALSE) {
			(*helpDefBuff[_BLOCKSTART])();
		} else {
			BlockStartOp();
		}
		break;
	case KEY_F(7):
		if (flag == FALSE) {
			(*helpDefBuff[_BLOCKYANC])();
		} else {
			BlockYancOp();
		}
		break;
	case KEY_F(8):
		if (flag == FALSE) {
			(*helpDefBuff[_BLOCKPASTE])();
		} else {
			BlockPasteOp();
		}
		break;
	case KEY_F(9):
		if (flag == FALSE) {
			(*helpDefBuff[_BLOCKMOVE])();
		} else {
			BlockMoveOp();
		}
		break;
	case KEY_F(10):
		if (flag == FALSE) {
			(*helpDefBuff[_BLOCKDELETE])();
		} else {
			BlockDeleteOp();
		}
		break;
	case KEY_DC:
		if (flag == FALSE) {
			(*helpDefBuff[_DELETECHAR])();
		} else {
			DeleteOp();
		}
		break;
	case KEY_IC:
		if (flag == FALSE) {
			(*helpDefBuff[_TOGGLEINPUTMODE])();
		} else {
			toggleInputMode();
		}
		break;
	case KEY_A1:
		if (flag == FALSE) {
			(*helpDefBuff[_CURSORUPSIDE])();
		} else {
			CursorUpSide();
		}
		break;
	case KEY_A3:
		if (flag == FALSE) {
			(*helpDefBuff[_ROLLUP])();
		} else {
			RollUpOp();
		}
		break;
	case KEY_C1:
		if (flag == FALSE) {
			(*helpDefBuff[_CURSORDOWNSIDE])();
		} else {
			CursorDownSide();
		}
		break;
	case KEY_C3:
		if (flag == FALSE) {
			(*helpDefBuff[_ROLLDOWN])();
		} else {
			RollDownOp();
		}
		break;
	case KEY_END:
		if (flag == FALSE) {
			(*helpDefBuff[_UNDOLINE])();
		} else {
			DoUndo();
		}
		break;
	case KEY_EXIT:
			break;
	case KEY_FIND:
		if (flag == FALSE) {
			(*helpDefBuff[_MULTIFILESEARCH])();
		} else {
			MultiFileSearch();
		}
		break;
	case KEY_SEND:
		if (flag == FALSE) {
			(*helpDefBuff[_CURSORENDSIDE])();
		} else {
			CursorEndSide();
		}
		break;
	case KEY_SHOME:
		if (flag == FALSE) {
			(*helpDefBuff[_CURSORTOPSIDE])();
		} else {
			CursorTopSide();
		}
		break;
	case KEY_SF:
		if (flag == FALSE) {
			(*helpDefBuff[_ROLLUP])();
		} else {
			RollUpOp();
		}
		break;
	case KEY_SR:
		if (flag == FALSE) {
			(*helpDefBuff[_ROLLDOWN])();
		} else {
			RollDownOp();
		}
		break;
	case KEY_NPAGE:
		if (flag == FALSE) {
			(*helpDefBuff[_SCROLLUP])();
		} else {
			ScrollUpOp();
		}
		break;
	case KEY_PPAGE:
		if (flag == FALSE) {
			(*helpDefBuff[_SCROLLDOWN])();
		} else {
			ScrollDownOp();
		}
		break;
	case KEY_BREAK:
		break;
	case KEY_BACKSPACE:
		if (flag == FALSE) {
			(*helpDefBuff[_BACKSPACE])();
		} else {
			BackSpaceOp();
		}
		break;
	case KEY_F0:
		break;
	case KEY_DL:
		break;
	case KEY_IL:
		break;
	case KEY_EIC:
		break;
	case KEY_CLEAR:
		break;
	case KEY_EOS:
		break;
	case KEY_EOL:
		break;
	case KEY_STAB:
		break;
	case KEY_CTAB:
		break;
	case KEY_CATAB:
		break;
	case KEY_ENTER:
		break;
	case KEY_SRESET:
		break;
	case KEY_PRINT:
		break;
	case KEY_LL:
		break;
	case KEY_B2:
		break;
	case KEY_BTAB:
		break;
	case KEY_BEG:
		break;
	case KEY_CANCEL:
		break;
	case KEY_CLOSE:
		break;
	case KEY_COMMAND:
		break;
	case KEY_COPY:
		break;
	case KEY_CREATE:
		break;
	case KEY_HELP:
		break;
	case KEY_MARK:
		break;
	case KEY_MESSAGE:
		break;
	case KEY_MOVE:
		break;
	case KEY_NEXT:
		break;
	case KEY_OPEN:
		break;
	case KEY_OPTIONS:
		break;
	case KEY_PREVIOUS:
		break;
	case KEY_REDO:
		break;
	case KEY_REFERENCE:
		break;
	case KEY_REFRESH:
		break;
	case KEY_REPLACE:
		break;
	case KEY_RESTART:
		break;
	case KEY_RESUME:
		break;
	case KEY_SAVE:
		break;
	case KEY_SBEG:
		break;
	case KEY_SCANCEL:
		break;
	case KEY_SCOMMAND:
		break;
	case KEY_SCOPY:
		break;
	case KEY_SCREATE:
		break;
	case KEY_SDC:
		break;
	case KEY_SDL:
		break;
	case KEY_SELECT:
		break;
	case KEY_SEOL:
		break;
	case KEY_SEXIT:
		break;
	case KEY_SFIND:
		break;
	case KEY_SHELP:
		break;
	case KEY_SIC:
		break;
	case KEY_SLEFT:
		break;
	case KEY_SMESSAGE:
		break;
	case KEY_SMOVE:
		break;
	case KEY_SNEXT:
		break;
	case KEY_SOPTIONS:
		break;
	case KEY_SPREVIOUS:
		break;
	case KEY_SPRINT:
		break;
	case KEY_SREDO:
		break;
	case KEY_SREPLACE:
		break;
	case KEY_SRIGHT:
		break;
	case KEY_SRSUME:
		break;
	case KEY_SSAVE:
		break;
	case KEY_SSUSPEND:
		break;
	case KEY_SUNDO:
		break;
	case KEY_SUSPEND:
		break;
	case KEY_UNDO:
		break;
	default:
		return FALSE;
	}
	return TRUE;
}
